Index: trunk/server/common/oursrc/nss_nonlocal/nonlocal-passwd.c
===================================================================
--- trunk/server/common/oursrc/nss_nonlocal/nonlocal-passwd.c	(revision 1553)
+++ trunk/server/common/oursrc/nss_nonlocal/nonlocal-passwd.c	(revision 1825)
@@ -50,12 +50,20 @@
 
 
-static service_user *
-nss_passwd_nonlocal_database(void)
-{
-    static service_user *nip = NULL;
-    if (nip == NULL)
-	__nss_database_lookup("passwd_nonlocal", NULL, "", &nip);
-
-    return nip;
+static service_user *__nss_passwd_nonlocal_database;
+
+static int
+internal_function
+__nss_passwd_nonlocal_lookup(service_user **ni, const char *fct_name,
+			     void **fctp)
+{
+    if (__nss_passwd_nonlocal_database == NULL
+	&& __nss_database_lookup("passwd_nonlocal", NULL, NULL,
+				 &__nss_passwd_nonlocal_database) < 0)
+	return -1;
+
+    *ni = __nss_passwd_nonlocal_database;
+
+    *fctp = __nss_lookup_function(*ni, fct_name);
+    return 0;
 }
 
@@ -64,53 +72,20 @@
 check_nonlocal_uid(const char *user, uid_t uid, int *errnop)
 {
-    static const char *fct_name = "getpwuid_r";
-    static service_user *startp = NULL;
-    static void *fct_start = NULL;
-    enum nss_status status;
-    service_user *nip;
-    union {
-	enum nss_status (*l)(uid_t uid, struct passwd *pwd,
-			     char *buffer, size_t buflen, int *errnop);
-	void *ptr;
-    } fct;
+    enum nss_status status;
     struct passwd pwbuf;
-    int old_errno = errno;
-
+    char *buf;
     size_t buflen = sysconf(_SC_GETPW_R_SIZE_MAX);
-    char *buf = malloc(buflen);
-    if (buf == NULL) {
-	*errnop = ENOMEM;
-	errno = old_errno;
-	return NSS_STATUS_TRYAGAIN;
-    }
-
-    if (fct_start == NULL &&
-	__nss_passwd_lookup(&startp, fct_name, &fct_start) != 0) {
-	free(buf);
-	return NSS_STATUS_UNAVAIL;
-    }
-    nip = startp;
-    fct.ptr = fct_start;
-    do {
-    morebuf:
-	if (fct.l == _nss_nonlocal_getpwuid_r)
-	    status = NSS_STATUS_NOTFOUND;
-	else
-	    status = DL_CALL_FCT(fct.l, (uid, &pwbuf, buf, buflen, errnop));
-	if (status == NSS_STATUS_TRYAGAIN && *errnop == ERANGE) {
-	    free(buf);
-	    buflen *= 2;
-	    buf = malloc(buflen);
-	    if (buf == NULL) {
-		*errnop = ENOMEM;
-		errno = old_errno;
-		return NSS_STATUS_TRYAGAIN;
-	    }
-	    goto morebuf;
-	}
-    } while (__nss_next(&nip, fct_name, &fct.ptr, status, 0) == 0);
+    const struct walk_nss w = {
+	.lookup = &__nss_passwd_lookup, .fct_name = "getpwuid_r",
+	.status = &status, .errnop = errnop, .buf = &buf, .buflen = &buflen
+    };
+    const __typeof__(&_nss_nonlocal_getpwuid_r) self = &_nss_nonlocal_getpwuid_r;
+#define args (uid, &pwbuf, buf, buflen, errnop)
+#include "walk_nss.h"
+#undef args
 
     if (status == NSS_STATUS_SUCCESS) {
 	syslog(LOG_ERR, "nss_nonlocal: possible spoofing attack: non-local user %s has same UID as local user %s!\n", user, pwbuf.pw_name);
+	free(buf);
 	status = NSS_STATUS_NOTFOUND;
     } else if (status != NSS_STATUS_TRYAGAIN) {
@@ -118,5 +93,4 @@
     }
 
-    free(buf);
     return status;
 }
@@ -132,7 +106,10 @@
     errno = 0;
     uid = strtoul(pwd->pw_name, &end, 10);
-    if (errno == 0 && *end == '\0' && (uid_t)uid == uid)
+    if (errno == 0 && *end == '\0' && (uid_t)uid == uid) {
+	errno = old_errno;
 	status = check_nonlocal_uid(user, uid, errnop);
-    errno = old_errno;
+    } else {
+	errno = old_errno;
+    }
     if (status != NSS_STATUS_SUCCESS)
 	return status;
@@ -144,62 +121,46 @@
 check_nonlocal_user(const char *user, int *errnop)
 {
-    static const char *fct_name = "getpwnam_r";
-    static service_user *startp = NULL;
-    static void *fct_start = NULL;
-    enum nss_status status;
-    service_user *nip;
-    union {
-	enum nss_status (*l)(const char *name, struct passwd *pwd,
-			     char *buffer, size_t buflen, int *errnop);
-	void *ptr;
-    } fct;
+    enum nss_status status;
     struct passwd pwbuf;
-    int old_errno = errno;
-
+    char *buf;
     size_t buflen = sysconf(_SC_GETPW_R_SIZE_MAX);
-    char *buf = malloc(buflen);
-    if (buf == NULL) {
-	*errnop = ENOMEM;
-	errno = old_errno;
-	return NSS_STATUS_TRYAGAIN;
-    }
-
-    if (fct_start == NULL &&
-	__nss_passwd_lookup(&startp, fct_name, &fct_start) != 0) {
+    const struct walk_nss w = {
+	.lookup = __nss_passwd_lookup, .fct_name = "getpwnam_r",
+	.status = &status, .errnop = errnop, .buf = &buf, .buflen = &buflen
+    };
+    const __typeof__(&_nss_nonlocal_getpwnam_r) self = &_nss_nonlocal_getpwnam_r;
+#define args (user, &pwbuf, buf, buflen, errnop)
+#include "walk_nss.h"
+#undef args
+
+    if (status == NSS_STATUS_SUCCESS) {
 	free(buf);
-	return NSS_STATUS_UNAVAIL;
-    }
-    nip = startp;
-    fct.ptr = fct_start;
-    do {
-    morebuf:
-	if (fct.l == _nss_nonlocal_getpwnam_r)
-	    status = NSS_STATUS_NOTFOUND;
-	else
-	    status = DL_CALL_FCT(fct.l, (user, &pwbuf, buf, buflen, errnop));
-	if (status == NSS_STATUS_TRYAGAIN && *errnop == ERANGE) {
-	    free(buf);
-	    buflen *= 2;
-	    buf = malloc(buflen);
-	    if (buf == NULL) {
-		*errnop = ENOMEM;
-		errno = old_errno;
-		return NSS_STATUS_TRYAGAIN;
-	    }
-	    goto morebuf;
-	}
-    } while (__nss_next(&nip, fct_name, &fct.ptr, status, 0) == 0);
-
-    if (status == NSS_STATUS_SUCCESS)
 	status = NSS_STATUS_NOTFOUND;
-    else if (status != NSS_STATUS_TRYAGAIN)
+    } else if (status != NSS_STATUS_TRYAGAIN) {
 	status = NSS_STATUS_SUCCESS;
-
-    free(buf);
+    }
+
     return status;
 }
 
-
-static service_user *pwent_nip = NULL;
+enum nss_status
+get_nonlocal_passwd(const char *name, struct passwd *pwd, char **buffer,
+		    int *errnop)
+{
+    enum nss_status status;
+    size_t buflen = sysconf(_SC_GETPW_R_SIZE_MAX);
+    const struct walk_nss w = {
+	.lookup = __nss_passwd_nonlocal_lookup, .fct_name = "getpwnam_r",
+	.status = &status, .errnop = errnop, .buf = buffer, .buflen = &buflen
+    };
+    const __typeof__(&_nss_nonlocal_getpwnam_r) self = NULL;
+#define args (name, pwd, *buffer, buflen, errnop)
+#include "walk_nss.h"
+#undef args
+    return status;
+}
+
+
+static service_user *pwent_startp, *pwent_nip;
 static void *pwent_fct_start;
 static union {
@@ -213,31 +174,20 @@
 _nss_nonlocal_setpwent(int stayopen)
 {
-    static const char *fct_name = "setpwent";
-    static void *fct_start = NULL;
-    enum nss_status status;
-    service_user *nip;
-    union {
-	enum nss_status (*l)(int stayopen);
-	void *ptr;
-    } fct;
-
-    nip = nss_passwd_nonlocal_database();
-    if (nip == NULL)
-	return NSS_STATUS_UNAVAIL;
-    if (fct_start == NULL)
-	fct_start = __nss_lookup_function(nip, fct_name);
-    fct.ptr = fct_start;
-    do {
-	if (fct.ptr == NULL)
-	    status = NSS_STATUS_UNAVAIL;
-	else
-	    status = DL_CALL_FCT(fct.l, (stayopen));
-    } while (__nss_next(&nip, fct_name, &fct.ptr, status, 0) == 0);
-    if (status != NSS_STATUS_SUCCESS)
-	return status;
-
-    pwent_nip = nip;
+    enum nss_status status;
+    const struct walk_nss w = {
+	.lookup = &__nss_passwd_nonlocal_lookup, .fct_name = "setpwent",
+	.status = &status
+    };
+    const __typeof__(&_nss_nonlocal_setpwent) self = NULL;
+#define args (stayopen)
+#include "walk_nss.h"
+#undef args
+    if (status != NSS_STATUS_SUCCESS)
+	return status;
+
     if (pwent_fct_start == NULL)
-	pwent_fct_start = __nss_lookup_function(nip, pwent_fct_name);
+	__nss_passwd_nonlocal_lookup(&pwent_startp, pwent_fct_name,
+				     &pwent_fct_start);
+    pwent_nip = pwent_startp;
     pwent_fct.ptr = pwent_fct_start;
     return NSS_STATUS_SUCCESS;
@@ -247,27 +197,16 @@
 _nss_nonlocal_endpwent(void)
 {
-    static const char *fct_name = "endpwent";
-    static void *fct_start = NULL;
-    enum nss_status status;
-    service_user *nip;
-    union {
-	enum nss_status (*l)(void);
-	void *ptr;
-    } fct;
+    enum nss_status status;
+    const struct walk_nss w = {
+	.lookup = &__nss_passwd_nonlocal_lookup, .fct_name = "endpwent",
+	.status = &status
+    };
+    const __typeof__(&_nss_nonlocal_endpwent) self = NULL;
 
     pwent_nip = NULL;
 
-    nip = nss_passwd_nonlocal_database();
-    if (nip == NULL)
-	return NSS_STATUS_UNAVAIL;
-    if (fct_start == NULL)
-	fct_start = __nss_lookup_function(nip, fct_name);
-    fct.ptr = fct_start;
-    do {
-	if (fct.ptr == NULL)
-	    status = NSS_STATUS_UNAVAIL;
-	else
-	    status = DL_CALL_FCT(fct.l, ());
-    } while (__nss_next(&nip, fct_name, &fct.ptr, status, 0) == 0);
+#define args ()
+#include "walk_nss.h"
+#undef args
     return status;
 }
@@ -314,14 +253,11 @@
 			 char *buffer, size_t buflen, int *errnop)
 {
-    static const char *fct_name = "getpwnam_r";
-    static void *fct_start = NULL;
-    enum nss_status status;
-    service_user *nip;
-    union {
-	enum nss_status (*l)(const char *name, struct passwd *pwd,
-			     char *buffer, size_t buflen, int *errnop);
-	void *ptr;
-    } fct;
+    enum nss_status status;
     int group_errno;
+    const struct walk_nss w = {
+	.lookup = __nss_passwd_nonlocal_lookup, .fct_name = "getpwnam_r",
+	.status = &status, .errnop = errnop
+    };
+    const __typeof__(&_nss_nonlocal_getpwnam_r) self = NULL;
 
     char *nonlocal_ignore = getenv(NONLOCAL_IGNORE_ENV);
@@ -329,18 +265,7 @@
 	return NSS_STATUS_UNAVAIL;
 
-    nip = nss_passwd_nonlocal_database();
-    if (nip == NULL)
-	return NSS_STATUS_UNAVAIL;
-    if (fct_start == NULL)
-	fct_start = __nss_lookup_function(nip, fct_name);
-    fct.ptr = fct_start;
-    do {
-	if (fct.ptr == NULL)
-	    status = NSS_STATUS_UNAVAIL;
-	else
-	    status = DL_CALL_FCT(fct.l, (name, pwd, buffer, buflen, errnop));
-	if (status == NSS_STATUS_TRYAGAIN && *errnop == ERANGE)
-	    break;
-    } while (__nss_next(&nip, fct_name, &fct.ptr, status, 0) == 0);
+#define args (name, pwd, buffer, buflen, errnop)
+#include "walk_nss.h"
+#undef args
     if (status != NSS_STATUS_SUCCESS)
 	return status;
@@ -355,5 +280,5 @@
 	return status;
 
-    if (check_nonlocal_gid(name, pwd->pw_gid, &group_errno) !=
+    if (check_nonlocal_gid(name, NULL, pwd->pw_gid, &group_errno) !=
 	NSS_STATUS_SUCCESS)
 	pwd->pw_gid = 65534 /* nogroup */;
@@ -365,14 +290,11 @@
 			 char *buffer, size_t buflen, int *errnop)
 {
-    static const char *fct_name = "getpwuid_r";
-    static void *fct_start = NULL;
-    enum nss_status status;
-    service_user *nip;
-    union {
-	enum nss_status (*l)(uid_t uid, struct passwd *pwd,
-			     char *buffer, size_t buflen, int *errnop);
-	void *ptr;
-    } fct;
+    enum nss_status status;
     int group_errno;
+    const struct walk_nss w = {
+	.lookup = &__nss_passwd_nonlocal_lookup, .fct_name = "getpwuid_r",
+	.status = &status, .errnop = errnop
+    };
+    const __typeof__(&_nss_nonlocal_getpwuid_r) self = NULL;
 
     char *nonlocal_ignore = getenv(NONLOCAL_IGNORE_ENV);
@@ -380,18 +302,7 @@
 	return NSS_STATUS_UNAVAIL;
 
-    nip = nss_passwd_nonlocal_database();
-    if (nip == NULL)
-	return NSS_STATUS_UNAVAIL;
-    if (fct_start == NULL)
-	fct_start = __nss_lookup_function(nip, fct_name);
-    fct.ptr = fct_start;
-    do {
-	if (fct.ptr == NULL)
-	    status = NSS_STATUS_UNAVAIL;
-	else
-	    status = DL_CALL_FCT(fct.l, (uid, pwd, buffer, buflen, errnop));
-	if (status == NSS_STATUS_TRYAGAIN && *errnop == ERANGE)
-	    break;
-    } while (__nss_next(&nip, fct_name, &fct.ptr, status, 0) == 0);
+#define args (uid, pwd, buffer, buflen, errnop)
+#include "walk_nss.h"
+#undef args
     if (status != NSS_STATUS_SUCCESS)
 	return status;
@@ -406,5 +317,5 @@
 	return status;
 
-    if (check_nonlocal_gid(pwd->pw_name, pwd->pw_gid, &group_errno) !=
+    if (check_nonlocal_gid(pwd->pw_name, NULL, pwd->pw_gid, &group_errno) !=
 	NSS_STATUS_SUCCESS)
 	pwd->pw_gid = 65534 /* nogroup */;
